#pragma once

// C++ system level
#include <functional>

// ESP32 specific
#include "freertos/FreeRTOS.h"
#include "freertos/task.h"


namespace SiliconTorch {
  namespace Util {

    typedef std::function<void()> Function0;


    // TODO: add destructor which deletes the task!

    class LambdaTask {
      public:
        LambdaTask(Function0 body);

        void kill();
        bool running();

        TaskHandle_t getHandle();

      private:

        bool _running = true;

        Function0 body;
        TaskHandle_t taskHandle;
    };

  }
}
