
use <PCB.scad>;
use <Material.scad>;
use <../../WebWeaver/scad/Util.scad>;


$fs = 0.5;
$fa = 1.0;

$str = 3;
$E   = 0.001;  // ε

plexi = 3;

// c = case
c_sx = PCB("pcb_sx") + 0;
c_sy = PCB("pcb_sy") + 0;
c_sz = 20;
c_fs = 15;  // frontSpace = pcb to upper plexi



module frontPlexiOutline() {
  /* pcbScrewHoles()
    circle(d=PCB("M3")*2); */
  
  txy = PCB("sc_left_off")+PCB("M3");

  translate([-PCB("pcb_sx")/2, -PCB("pcb_sy")/2])
    mixedRoundRect(txy, txy, [0, PCB("pcb_edge_r"), 0, PCB("M3")]);
  
  translate([-PCB("pcb_sx")/2, PCB("pcb_sy")/2 - txy])
    mixedRoundRect(txy, txy, [PCB("pcb_edge_r"), 0, PCB("M3"), 0]);
  
  
}

module frontPlexi() {
  Plexiglass()
    linear_extrude(plexi, convexity=20)
      frontPlexiOutline();
}


module CyanStripeCase() {
  cube();
}





if ($preview) {

  pcb3D();

  translate([0, 0, PCB("pcb_t")+aj_h()])
    frontPlexi();

} else if ($part == "CoverGlass") {

  frontPlexiOutline();

} else if ($part == "Frame") {

  CyanStripeCase();

}

